/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
https://github.com/DonatoMeoli/WS4J
 */
package FunctionLayer.misc;

import edu.cmu.lti.jawjaw.pobj.POS;
import edu.cmu.lti.lexical_db.ILexicalDatabase;
import edu.cmu.lti.lexical_db.NictWordNet;
import edu.cmu.lti.lexical_db.data.Concept;
import edu.cmu.lti.ws4j.Relatedness;
import edu.cmu.lti.ws4j.RelatednessCalculator;
import edu.cmu.lti.ws4j.impl.HirstStOnge;
import edu.cmu.lti.ws4j.impl.JiangConrath;
import edu.cmu.lti.ws4j.impl.LeacockChodorow;
import edu.cmu.lti.ws4j.impl.Lesk;
import edu.cmu.lti.ws4j.impl.Lin;
import edu.cmu.lti.ws4j.impl.Path;
import edu.cmu.lti.ws4j.impl.Resnik;
import edu.cmu.lti.ws4j.impl.WuPalmer;

/**
 *
 * @author install1
 * https://www.programcreek.com/java-api-examples/?api=edu.cmu.lti.ws4j.RelatednessCalculator
 * https://stackoverflow.com/questions/36300485/how-to-resolve-the-difference-between-the-values-attained-in-the-web-api-and-the
 */
public class WordNetSimalarityObsolete {

    private static ILexicalDatabase db = new NictWordNet();
    private static RelatednessCalculator rc1 = new WuPalmer(db);
    private static RelatednessCalculator rc2 = new Resnik(db);
    private static RelatednessCalculator rc3 = new JiangConrath(db);
    private static RelatednessCalculator rc4 = new Lin(db);
    private static RelatednessCalculator rc5 = new LeacockChodorow(db);
    private static RelatednessCalculator rc6 = new Path(db);
    private static RelatednessCalculator rc7 = new Lesk(db);
    private static RelatednessCalculator rc8 = new HirstStOnge(db);

    public static double SentenceMatcherSimilarityMatrix(String[] words1, String[] words2, double maxScore) {
        {
            double[][] s1 = getSimilarityMatrix(words1, words2, rc1);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s1[i][j] < maxScore && s1[i][j] > 0.0) {
                        System.out.print(s1[i][j] + "\t");
                        System.out.println("WuPalmer");
                        maxScore = s1[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc2);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("Resnik");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc3);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("JiangConrath");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc4);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("Lin");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc5);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.print(s2[i][j] + "\t");
                        System.out.println("LeacockChodrow");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc6);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("Path");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc7);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("Lesk");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        {
            double[][] s2 = getSimilarityMatrix(words1, words2, rc8);
            for (int i = 0; i < words1.length; i++) {
                for (int j = 0; j < words2.length; j++) {
                    if (s2[i][j] < maxScore && s2[i][j] > 0.0) {
                        System.out.println("HirstStOnge");
                        System.out.print(s2[i][j] + "\t");
                        maxScore = s2[i][j];
                    }
                }
            }
        }
        return maxScore;
    }

    public static double[][] getSimilarityMatrix(String[] words1, String[] words2, RelatednessCalculator rc) {
        double[][] result = new double[words1.length][words2.length];
        for (int i = 0; i < words1.length; i++) {
            for (int j = 0; j < words2.length; j++) {
                double score = rc.calcRelatednessOfWords(words1[i], words2[j]);
                result[i][j] = score;
            }
        }
        return result;
    }
}
