/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DBAcess;

import FunctionLayer.ErrorMessageDisplay;
import FunctionLayer.MapBoard;
import FunctionLayer.MapValues;
import FunctionLayer.RecentTimes;
import FunctionLayer.UserBanners;
import FunctionLayer.Users;
import com.google.common.base.Stopwatch;
import com.google.common.collect.HashBiMap;
import java.beans.PropertyVetoException;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.charset.Charset;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.json.JSONException;
import org.json.JSONObject;

/**
 *
 * @author install1
 */
public class DataMapper {

    private static String DefaultAvatar = "https://steamcdn-a.akamaihd.net/steamcommunity/public/images/avatars/fe/fef49e7fa7e1997310d705b2a6158ff8dc1cdfeb_full.jpg";

    public static List<MapBoard> GetAllMapColoumns() throws SQLException, ErrorMessageDisplay, IOException, PropertyVetoException {
        List<MapBoard> AllMapColoumns = new ArrayList();
        List<MapValues> mv = new ArrayList();
        int prefixSkip = 3;
        MapBoard mapboardnames = null;
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "SELECT * FROM `zetimer_table` LIMIT 1;";
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            ResultSetMetaData metaData = l_rsSearch.getMetaData();
            for (int i = prefixSkip; i <= metaData.getColumnCount(); i++) {
                mapboardnames = new MapBoard(metaData.getColumnLabel(i), mv);
                AllMapColoumns.add(mapboardnames);
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper 1 " + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        Collections.sort(AllMapColoumns,
                (d1, d2) -> d1.getMapName().compareTo(d2.getMapName()));
        return AllMapColoumns;
    }

    public static List<Users> getAllUsersNameSteamIdInitialization() throws SQLException, ErrorMessageDisplay, IOException, PropertyVetoException {
        List<Users> userlist = new ArrayList();
        Users user = null;
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            String l_sSQL = "SELECT steam_auth, name FROM `zetimer_table`";
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                user = new Users(l_rsSearch.getString(1), l_rsSearch.getString(2), "", 0, 0, 0);
                userlist.add(user);
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper 2 " + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return userlist;
    }

    public static LinkedHashMap<Users, Float> GetMapTimes(String mapindexes, List<Users> LeaderBoard, LinkedHashMap<String, Users> Usermap) throws ErrorMessageDisplay {
        String l_sSQL = "SELECT steam_auth, "
                + mapindexes + " FROM `zetimer_table` WHERE "
                + mapindexes + " > 0.00 ORDER BY "
                + mapindexes + " ASC;";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        LinkedHashMap<Users, Float> usertimes = new LinkedHashMap();
        Users user;
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                user = Usermap.get(l_rsSearch.getString(1));
                usertimes.put(user, l_rsSearch.getFloat(2));
            }
            l_cCon.close();
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper GetMapTimes sql: " + l_sSQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return usertimes;
    }

    public static List<Users> SetUsersAvatars(List<Users> userAvatarLinks) throws IOException, ErrorMessageDisplay, SQLException {
        String l_SQL = "SELECT * FROM `userStrings`";
        HashBiMap<String, String> strList = HashBiMap.create();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                strList.put(l_rsSearch.getString(1), l_rsSearch.getString(2));
            }
            for (int i = 0; i < userAvatarLinks.size(); i++) {
                String str = strList.inverse().get(userAvatarLinks.get(i).getSteamID());
                if (str != null) {
                    userAvatarLinks.get(i).setAvatar(str);
                } else {
                    userAvatarLinks.get(i).setAvatar(DefaultAvatar);
                }
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("Datamapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return userAvatarLinks;
    }

    public synchronized static void UpdatePlayerAvatarsToDB(List<Users> userAvatars, List<String> ConvertedID, int start, int end) throws ErrorMessageDisplay, MalformedURLException, IOException {
        List<String> arr = new ArrayList();
        String Avatar = "";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_sSQL = "CREATE TABLE IF NOT EXISTS `userStrings` (`strings` VARCHAR(254) NOT NULL, `steam_auth` VARCHAR(65) NOT NULL, PRIMARY KEY (`steam_auth`));";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_sSQL);
            l_pStatement.executeUpdate();
            for (int i = start; i < end; i++) {
                StringBuilder sb = new StringBuilder();
                URL url = new URL("http://api.steampowered.com/ISteamUser/GetPlayerSummaries/v0002/?key=262F3F0C6B83E0F263C272C3762002F1&steamids="
                        + ConvertedID.get(i));
                try (InputStream is = url.openStream();
                        InputStreamReader in = new InputStreamReader(is);
                        BufferedReader reader = new BufferedReader(in)) {
                    String word;
                    while ((word = reader.readLine()) != null) {
                        sb.append(word);
                    }
                }
                arr.add(sb.toString());
            }
            for (int i = start; i < end; i++) {
                if (arr.get(i).contains("avatarfull\":")) {
                    Avatar = arr.get(i).substring(arr.get(i).indexOf("avatarfull\":") + 13, arr.get(i).indexOf("\",\"personastate"));
                    l_sSQL = "INSERT INTO `userStrings` (`steam_auth`, `strings`) VALUES ('" + userAvatars.get(i).getSteamID()
                            + "', '" + Avatar + "') ON DUPLICATE KEY UPDATE `strings` = '" + Avatar + "'";
                    l_pStatement.addBatch(l_sSQL);
                }
            }
            l_pStatement.executeBatch();
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper 5 sql: " + l_sSQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    /**
     * @deprecated @param PlayerIndexSteamID
     * @return
     * @throws ErrorMessageDisplay
     * @throws SQLException
     * @throws IOException
     * @throws PropertyVetoException
     */
    public static List<Float> GetSpecificPlayerTimes(String PlayerIndexSteamID) throws ErrorMessageDisplay, SQLException, IOException, PropertyVetoException {
        List<Float> PlayerTimes = new ArrayList();
        List<MapBoard> AllMaps = GetAllMapColoumns();
        String l_sSQL = "";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            for (int i = 0; i < AllMaps.size(); i++) {
                l_sSQL = "SELECT " + AllMaps.get(i).getMapName() + " FROM `zetimer_table` WHERE steam_auth = '" + PlayerIndexSteamID + "'"
                        + " AND " + AllMaps.get(i).getMapName() + " > 0.00";
                l_pStatement = l_cCon.prepareStatement(l_sSQL);
                l_rsSearch = l_pStatement.executeQuery();
                if (l_rsSearch.next()) {
                    PlayerTimes.add(l_rsSearch.getFloat(1));
                }
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_sSQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return PlayerTimes;
    }

    public static List<MapBoard> GetPlayerRelatedMaps(String PlayerIndexSteamID) throws ErrorMessageDisplay, SQLException, IOException, PropertyVetoException {
        List<MapBoard> AllPlayerRelatedMaps = new ArrayList();
        List<MapValues> mv = new ArrayList();
        List<MapBoard> AllMaps = GetAllMapColoumns();
        MapBoard map = null;
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_SQL = "";
        try {
            l_cCon = DBCPDataSource.getConnection();
            for (int i = 0; i < AllMaps.size(); i++) {
                l_SQL = "SELECT " + AllMaps.get(i).getMapName() + " FROM `zetimer_table` WHERE steam_auth = '" + PlayerIndexSteamID + "'";
                l_pStatement = l_cCon.prepareStatement(l_SQL);
                l_rsSearch = l_pStatement.executeQuery();
                if (l_rsSearch.next()) {
                    if (l_rsSearch.getFloat(1) > 0.0) {
                        map = new MapBoard(AllMaps.get(i).getMapName(), mv);
                        AllPlayerRelatedMaps.add(map);
                    }
                }
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return AllPlayerRelatedMaps;
    }

    public static int GetAdmin(String name, String psw) throws ErrorMessageDisplay {
        String l_SQL = "";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_SQL = "CREATE TABLE IF NOT EXISTS `Admins` (`username` VARCHAR(64) NOT NULL, `password` VARCHAR(65) NOT NULL, `role` VARCHAR(65) NOT NULL, PRIMARY KEY (`username`));";
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_pStatement.executeUpdate();
            l_SQL = "SELECT role FROM `Admins` WHERE username = '" + name + "' AND password = '" + psw + "'";
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            if (l_rsSearch.next()) {
                switch (l_rsSearch.getString(1)) {
                    case "Tech": {
                        return 3;
                    }
                    case "Global Admin": {
                        return 2;
                    }
                    case "Admin": {
                        return 1;
                    }
                }
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return 0;
    }

    public static void DeleteMapEntry(String map, String steamID) throws ErrorMessageDisplay {
        String l_SQL = "";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_SQL = "UPDATE `zetimer_table` SET `" + map + "` = 0.000 WHERE `steam_auth` = '" + steamID + "';";
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_pStatement.executeUpdate();
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    public static MapBoard getCurrentMap() throws IOException, ErrorMessageDisplay {
        String GetCurrentmap = "https://api.steampowered.com/IGameServersService/GetServerList/v1/?key=262F3F0C6B83E0F263C272C3762002F1&filter=addr\\151.80.230.149:27015&limit=1";
        JSONObject json = readJsonFromUrl(GetCurrentmap);
        String sjson = json.toString();
        List<MapValues> mv = new ArrayList();
        MapBoard map = new MapBoard(sjson.substring(sjson.indexOf("map\":\"") + 6, sjson.indexOf("\",\"specport\"")), mv);
        return map;
    }

    private static String readAll(Reader rd) throws IOException {
        StringBuilder sb = new StringBuilder();
        int cp;
        while ((cp = rd.read()) != -1) {
            sb.append((char) cp);
        }
        return sb.toString();
    }

    public static JSONObject readJsonFromUrl(String url) throws IOException, JSONException {
        InputStream is = new URL(url).openStream();
        BufferedReader rd = new BufferedReader(new InputStreamReader(is, Charset.forName("UTF-8")));
        String jsonText = readAll(rd);
        JSONObject json = new JSONObject(jsonText);
        return json;
    }

    public static List<String> getHlstatsxIngamePlayerSteamID() throws ErrorMessageDisplay {
        List<String> ingamePlayersSteamID = new ArrayList();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_SQL = "";
        try {
            l_cCon = DBCPDataSource2.getConnection();
            l_SQL = "SELECT steam_id FROM `hlstats_Livestats` WHERE server_id = 1";
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                ingamePlayersSteamID.add(l_rsSearch.getString(1));
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return ingamePlayersSteamID;
    }

    public static List<MapBoard> getCurrentMapLevels(MapBoard map) throws SQLException, ErrorMessageDisplay, IOException, PropertyVetoException {
        List<MapBoard> allColoumns = GetAllMapColoumns();
        List<MapBoard> currentLvls = new ArrayList();
        for (int i = 0; i < allColoumns.size(); i++) {
            if (allColoumns.get(i).getMapName().contains(map.getMapName())) {
                currentLvls.add(allColoumns.get(i));
            }
        }
        return currentLvls;
    }

    public static Map<String, String> getAllAdmins() throws ErrorMessageDisplay {
        Map<String, String> HM = new HashMap();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_SQL = "SELECT username, role FROM `Admins`";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                HM.put(l_rsSearch.getString(1), l_rsSearch.getString(2));
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return HM;
    }

    public static void createAdmin(String name, String password, String role) throws ErrorMessageDisplay {
        String l_SQL = "INSERT INTO `Admins` (`username`,`password`,`role`) VALUES (?, ?, ?)";
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_pStatement.setString(1, name);
            l_pStatement.setString(2, password);
            l_pStatement.setString(3, role);
            l_pStatement.executeUpdate();
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
    }

    public static LinkedHashMap<Users, Float> GetMapRelatedTimes(MapBoard mapname, List<Users> LeaderBoardInfo, Map<String, Users> UserMap) throws ErrorMessageDisplay {
        LinkedHashMap<Users, Float> LHM = new LinkedHashMap();
        int index = 0;
        int counter = 0;
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String l_SQL = "SELECT steam_auth, "
                + mapname.getMapName() + " FROM `zetimer_table` WHERE "
                + mapname.getMapName() + " > 0.00 ORDER BY "
                + mapname.getMapName() + " ASC;";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                counter++;
                Users user = UserMap.get(l_rsSearch.getString(1));
                index = LeaderBoardInfo.indexOf(user);
                LHM.put(LeaderBoardInfo.get(index), l_rsSearch.getFloat(2));
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper GetMapRelatedTimes sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return LHM;
    }

    public static List<UserBanners> getUserbanners(List<Users> PlayerLeaderBoard, List<String> ConvertedID) throws ErrorMessageDisplay {
        List<UserBanners> UBList = new ArrayList();
        UserBanners ub;
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        List<Integer> user_id = new ArrayList();
        List<Long> Provider_key = new ArrayList();
        List<Integer> user_group_id = new ArrayList();
        String l_SQL = "SELECT t2.user_id, t2.provider_key, t1.user_group_id FROM `xf_user_group_relation` t1, `xf_user_external_auth` t2  WHERE t1.user_id = t2.user_id AND t2.provider = \"steam\"";
        try {
            l_cCon = DBCPDataSource3.getConnection();
            l_pStatement = l_cCon.prepareStatement(l_SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next()) {
                user_id.add(l_rsSearch.getInt(1));
                Provider_key.add(l_rsSearch.getLong(2));
                user_group_id.add(l_rsSearch.getInt(3));
            }
            int indexIDs = 0;
            int counter = 0;
            while (indexIDs < user_id.size()) {
                List<Integer> Iarr = new ArrayList();
                while (indexIDs < user_id.size() && Provider_key.get(indexIDs).intValue() == Provider_key.get(counter).intValue()) {
                    //2 = user, 6 = mapper,  7 = admin, 8 = technical staff, 10 = leader,  12 = vip, 15 = event winner, 19 = discord manager, 20 NSFW, 25 = event manager
                    // 11 = GA
                    int groupID = user_group_id.get(indexIDs);
                    if (groupID == 6 || groupID == 7 || groupID == 8 || groupID == 10 || groupID == 11 || groupID == 12 || groupID == 15 || groupID == 19
                            || groupID == 25) {
                        Iarr.add(groupID);
                    }
                    indexIDs++;
                }
                counter = indexIDs;
                boolean end = false;
                if (indexIDs >= user_id.size()) {
                    indexIDs = user_id.size() - 1;
                    end = true;
                }
                int index = ConvertedID.indexOf(String.valueOf(Provider_key.get(indexIDs - 1)));
                if (index != -1) {
                    ub = new UserBanners(Iarr, PlayerLeaderBoard.get(index));
                    UBList.add(ub);
                }
                if (end) {
                    break;
                }
                /*
                if (Objects.equals(Provider_key.get(indexIDs - 1), Long.valueOf("76561198343747394"))) {
                    throw new ErrorMessageDisplay("UBList kaka size: " + UBList.get(UBList.size() - 1).getUrlBanners().size() 
                    + " name: " + UBList.get(UBList.size() - 1).getUser().getName());
                }
                 */
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper getUserbanners sql: " + l_SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return UBList;
    }

    public static List<RecentTimes> getRecentTimes() throws ErrorMessageDisplay {
        List<RecentTimes> RTlist = new ArrayList();
        Connection l_cCon = null;
        PreparedStatement l_pStatement = null;
        ResultSet l_rsSearch = null;
        String SQL = "SELECT * FROM `recenttimes_table`";
        try {
            l_cCon = DBCPDataSource.getConnection();
            l_pStatement = l_cCon.prepareStatement(SQL);
            l_rsSearch = l_pStatement.executeQuery();
            while (l_rsSearch.next() && RTlist.size() < 500) {
                RecentTimes RT = new RecentTimes(l_rsSearch.getString(2), l_rsSearch.getString(3), l_rsSearch.getFloat(4), null, 0);
                RTlist.add(RT);
            }
        } catch (SQLException ex) {
            throw new ErrorMessageDisplay("failed in DataMapper getRecentTimes sql: " + SQL + ex.getMessage());
        } finally {
            CloseConnections(l_pStatement, l_rsSearch, l_cCon);
        }
        return RTlist;
    }

    public static void CloseConnections(PreparedStatement ps, ResultSet rs, Connection con) {
        if (rs != null) {
            try {
                rs.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        if (ps != null) {
            try {
                ps.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        if (con != null) {
            try {
                con.close();
            } catch (SQLException ex) {
                Logger.getLogger(DataMapper.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
